### 一,目前状况
截止目前,由院方主导润普为主的统一存储项目已完成分布式对象存储系统的建设，为法院电子卷宗提供面向结构化及非结构化数据的统一存储管理平台,但是在按照原定流程调试接入过程中,由于卷宗文件多入口的情况以及多方可写入存储相关卷宗数据,导致第三方厂家和润普写入存储时可能出现数据冲突及版本覆盖等问题,特此润普方提供相关问题详细说明及相应解决方案,希望院方对方案做出相关建议及评定以便润普尽快推进统一存储调试尽早上线。
### 二,问题说明
如下流程图(1)为原定案件信息以及卷宗档案信息交互流程,此流程图(1)存在数据交互问题如下(已和华宇研发沟通过):
双方都可以随时更新文件,可能会导致双方同时更新同一案件相关卷宗信息,导致卷宗信息同时有两个不同版本,版本更新时会存在冲突情况,此流程无法避免版本冲突情况也没有解决冲突的相应机制。
![](https://doc.dev.whrunpu.com/uploads/uni-storage/images/m_3dc22ddc0452b4b2e4463691ca725d27_r.png)
<center>流程图(1)</center>
### 三,解决方案
针对统一存储调试过程中出现的卷宗版本冲突问题,润普提出如下两种解决方案:

方案1:
如流程图(2),此方案通过xml版本比对以及提供相关更新记录优化版本冲突流程,如果发现问题需要第三方公司安排人工通过历史版本比对并协商追溯版本解决问题。
冲突说明: 
1. A方修改卷宗，删除文件，排序文件，并成功写入存储库。B方在原卷宗上，新增文件文件，排序文件，删除文件，如果双方遇到对同一文件操作，这时该谁为主
     2. A方修改卷宗保存存储库并通知B方更新，B方在收到更新前，正在对这份卷宗上传文件，上传文件耗时长，当上传完成后，案卷重命名，归目等，也修改了本案卷，此时B方的案卷已经不是最新状态，但仍被B修改，此时又收到A方的案卷更新，同样存在数据冲突。

![](https://doc.dev.whrunpu.com/uploads/uni-storage/images/m_82c8381df4d6dde2e58a6d98de9ecb44_r.png)
<center>流程图(2)</center>
方案说明:
冲突1和冲突2状况可以完全通过人力去解决冲突,或者指定标准方,一旦发生冲突有相应准则遵循,根据相应准则去做数据合并,可以降低人力成本,但是无法避免完全不需要人为干预。冲突1以最后提交方为主,例如A和B同时修改卷宗移动同一文件,以最后提交方的文件所属位置为准,冲突2基础版本不一致的情况下,B方应该记录所有本次操作内容,再更新基础版本为最新,在最新版的基础上加上本次的操作内容,保障版本验证通过,再把结果提供给更新方验证合并。如果发现合并错误,需要人工通过历史更新记录去解决错误,恢复卷宗数据。
方案优势:
方案1优化版本冲突问题,避免出现版本覆盖问题。
方案劣势:
方案1优化版本冲突的同时,需要各公司投入人力去负责处理解决冲突问题。

方案2:
如流程图(3), 将卷宗信息变动放置润普业务系统处理,由润普业务系统统一合并更新,并将最新结果实时更新至统一存储,并实时通知第三方更新结果。

![](https://doc.dev.whrunpu.com/uploads/uni-storage/images/m_52d4fba60351f0aaee47673f6854ca17_r.png)

<center>流程图(3)</center>
方案优势:
方案2在方案1的基础上减少版本冲突概率,降低人力投入。
方案劣势:
方案2可能造成润普业务服务器压力增加,需要各公司统一标准使用润普相应API接口。

### 四,总结
   综上所述方案,润普建议以第2种方案为优,如果院方对以上方案有相关建议或者有其他方案指示,润普方以院方选择为准。